﻿//●傍罫・下線引き.jsx
//　横書きの下線と縦書きの傍罫を引くスクリプトです。
//　InDesignの下線・打消し線の位置を計算して引いているだけですので、消す方の機能は必要なかったかなとも思います。
//　ベースライン位置は仮想ボディの下端から12％で計算しています。（モリサワFONT）
//　MathMagicのmmaCenturyのベースラインは17％のようですのでベースライン位置を入力できるように改めました。
//　ベースラインシフト、文字サイズ、文字揃え位置（仮想ボディの中央・上／右・下／左）に対応しました。
//										2006.11.18/15:20 修正	(C)CopyRight Mishima Print Co.
//
//	1.このスクリプトを使用して何らかの損害が生じたとしても、責任は負いかねますので、自己責任で使用して下さい。
//	2.このスクリプトを使い易いように、改変、改良をして同一部署ないで使用するのは構いません。
//	3.このスクリプト及び、改変、改良を加えたスクリプトを無償で再配布する場合にはご連絡ください。
//	4.このスクリプト及び、改変、改良を加えたスクリプトを有償で再配布する事は禁止します。
//
//						2006.12.08　三島梅花藻	/ Mishima Print Co.
//						e-mail：tuchiya☆mishima-print.co.jp	（☆を@に置き換えて下さい。）

if (app.documents.length != 0){
	if (app.selection.length == 1){
		switch (app.selection[0].constructor.name){
			case "Text":
			case "Character":
			case "Word":
			case "TextStyleRange":
			case "Paragraph":
			case "TextColumn":
				myDisplayDialog();
				break;
			default:
				alert("選択された部分はテキストではありません。テキストを範囲指定してください。");
				break;
		}
	}
	else{
		alert("テキスト部分を選択し直してください。");
	}
}
else{
	alert("No documents are open. Please open a document, select some text, and try again.");
}
function myDisplayDialog(){
	var myDoc = app.activeDocument;
	with (myDoc.viewPreferences){ 
		var myOldXUnits = horizontalMeasurementUnits; 
		var myOldYUnits = verticalMeasurementUnits;
		var myOldTypographUnits = typographicMeasurementUnits;
		var myOldTextUnits = textSizeMeasurementUnits;
		var myOldLineUnits = lineMeasurementUnits;
		//水平方向および垂直方向の測定単位を mm に、組版の測定単位をを 歯 に、テキストサイズをの測定単位を 級 に、線幅の測定単位を mm に設定します。
		horizontalMeasurementUnits = MeasurementUnits.millimeters; 
		verticalMeasurementUnits = MeasurementUnits.millimeters;
		typographicMeasurementUnits = MeasurementUnits.ha;
		textSizeMeasurementUnits = MeasurementUnits.q;
		lineMeasurementUnits = MeasurementUnits.millimeters;
	}
	var mySwatches = app.activeDocument.swatches;
	var SwatcheList = app.activeDocument.swatches.everyItem().name;
	var myFontSize = eval(app.selection[0].characters[0].pointSize);
	var udroff = myFontSize/2 + 1;
	var myStory = app.selection[0].parentStory;
	var StartPtr = app.selection[0].characters.firstItem().index;
	var TerminalPtr = app.selection[0].characters.lastItem().index;
	if (app.selection[0].parent.constructor.name=="Cell"){
		myStory = app.selection[0].parent;
	}
	var tategakiFlag = false;
	if (myStory.storyPreferences.storyOrientation==1986359924) tategakiFlag = true ;	//縦書き
	var myDialog;
	var widthLst = ["0.12","0.25","0.4","0.5"];	//線幅のリスト
	var udroffLst = [""+(myFontSize/2+1),""+(myFontSize/2+2),""+(myFontSize+1)]	//オフセットのリスト
	var baselineLst = ["12","14","17"];		//ベースライン位置(％)のリスト
	with(myDialog = app.dialogs.add({name:"傍罫・アンダーライン引き(縦・横兼用)スクリプト"})){
		with(dialogColumns.add()){
			with(borderPanels.add()){
				staticTexts.add({staticLabel:"操作:"});
				with(dialogColumns.add()){
					with(myCmd = radiobuttonGroups.add()){
						radiobuttonControls.add({staticLabel:"下線を用いて傍罫・アンダーラインを引く", checkedState:true});
						radiobuttonControls.add({staticLabel:"打消し線を用いて傍罫・アンダーラインを引く"});
						radiobuttonControls.add({staticLabel:"下線・打消し線、両方とも消去する"});
					}
				}
			}
			with(dialogRows.add()){
				with(dialogColumns.add()){	// ラベル類の列
					staticTexts.add({staticLabel:"線の種類:"});
					staticTexts.add({staticLabel:"仮想ボディの中央からの距離(歯):"});
					staticTexts.add({staticLabel:"線の幅(mm):"});
					staticTexts.add({staticLabel:"線のカラー:"});
					staticTexts.add({staticLabel:"ベースライン位置(％):"});
				}
				with(dialogColumns.add()){	// コントロール類の列
					UndrlineType = dropdowns.add({stringList: ["ベタ","二重線","波状"], selectedIndex:0});
					UndrlineOffset = realComboboxes.add({editValue:udroff,minimumValue:-400,maximumValue:400,smallNudge:1,stringList:udroffLst});
					UndrlineWeight = realComboboxes.add({editValue:0.25,minimumValue:0,maximumValue:10,smallNudge:0.1,stringList:widthLst});
					ulSwatch = dropdowns.add({stringList:SwatcheList, selectedIndex:2});
					BaseLined = realComboboxes.add({editValue:12,minimumValue:0,maximumValue:100,smallNudge:1,stringList:baselineLst});
				}
			}
		}
	}
	myReturn = myDialog.show();
	if (myReturn){
		var baselines = (50 - BaseLined.editValue)/100.0;
		var baselineu = BaseLined.editValue/100.0;
		if (tategakiFlag){		//縦書き
			switch (myCmd.selectedButton){
				case 0 :
					for (i = StartPtr;i <= TerminalPtr;i ++){
						with (myStory.characters[i]){
							if (tracking != -1000){
								var chroffset = myFontSize * horizontalScale / 100 * baselines;
								underlineOffset = (baselineShift - chroffset - eval(UndrlineOffset.editValue)) / 4;
								if (pointSize != myFontSize){
									var doffset = 0;
									switch (characterAlignment){
									case 1247896436:	//仮想ボディの中央
										doffset = (myFontSize-pointSize)*baselines/4;
										break;
									case 1247900784:	//仮想ボディの上/右
										doffset = (myFontSize-pointSize)*(0.5+baselines)/4;
										break;
									case 1247896173:	//仮想ボディの下/左
										doffset = -(myFontSize-pointSize)*(0.5-baselines)/4;
										break;
									}
									underlineOffset += doffset;
								} 
								switch (UndrlineType.selectedIndex){
									case 0 : underlineType = "ベタ";
										break ;
									case 1 : underlineType = "二重線";
										break ;
									case 2 : underlineType = "波状";
										break ;
								}
								underlineWeight = eval(UndrlineWeight.editValue);
								underlineColor = mySwatches[ulSwatch.selectedIndex].name;
								underline = true;
							}
						}
					}
					with (myStory.characters[TerminalPtr]){
						if ((contents == "。" || contents == "、") && tracking == 0){
							contents = contents + String.fromCharCode("0x2002");
							tracking = -500;
							myStory.characters[TerminalPtr+1].underline = false;
						}
					}
					break;
				case 1 :
					for (i = StartPtr;i <= TerminalPtr;i ++){
						with (myStory.characters[i]){
							if (tracking != -1000){
								var chroffset = myFontSize * baselines;
								strikeThroughOffset = -(baselineShift - chroffset - eval(UndrlineOffset.editValue)) / 4;
								if (pointSize != myFontSize){
									var doffset = 0;
									switch (characterAlignment){
									case 1247896436:	//仮想ボディの中央
										doffset = (myFontSize-pointSize)*baselines/4;
										break;
									case 1247900784:	//仮想ボディの上/右
										doffset = (myFontSize-pointSize)*(0.5+baselines)/4;
										break;
									case 1247896173:	//仮想ボディの下/左
										doffset = -(myFontSize-pointSize)*(0.5-baselines)/4;
										break;
									}
									strikeThroughOffset -= doffset;
								} 
								switch (UndrlineType.selectedIndex){
									case 0 : strikeThroughType = "ベタ";
										break ;
									case 1 : strikeThroughType = "二重線";
										break ;
									case 2 : strikeThroughType = "波状";
										break ;
								}
								strikeThroughWeight = eval(UndrlineWeight.editValue);
								strikeThroughColor = mySwatches[ulSwatch.selectedIndex].name;
								strikeThru = true;
							}
						}
					}
					with (myStory.characters[TerminalPtr]){
						if ((contents == "。" || contents == "、") && tracking == 0){
							contents = contents + String.fromCharCode("0x2002");
							tracking = -500;
							myStory.characters[TerminalPtr+1].strikeThru = false;
						}
					}
					break;
				case 2 :
					for (i = StartPtr;i <= TerminalPtr;i ++){
						myStory.characters[i].underline = false;
						myStory.characters[i].strikeThru = false;
					}
					break;
			}
		} else {			//横書き
			switch (myCmd.selectedButton){
			case 0 :
				with (myStory.characters[StartPtr]){
					if (contents=="（"||contents=="『"){
						leadingAki = 0;
					}
				}
				with (myStory.characters[TerminalPtr]){
					if (contents=="）"||contents=="』"){
						contents=contents + String.fromCharCode("0x2002");
						trailingAki = 0;
					}
				}
				for (var i = StartPtr;i <= TerminalPtr;i ++){
					with (myStory.characters[i]){
						var chroffset = myFontSize * verticalScale / 100 * baselines;
						underlineOffset = ( - chroffset + eval(UndrlineOffset.editValue)+baselineShift) / 4;
						if (pointSize != myFontSize){
							var doffset = 0;
							switch (characterAlignment){
							case 1247896436:	//仮想ボディの中央
								doffset = (myFontSize-pointSize)*baselines/4;
								break;
							case 1247900784:	//仮想ボディの上/右
								doffset = (myFontSize-pointSize)*(0.5+baselines)/4;
								break;
							case 1247896173:	//仮想ボディの下/左
								doffset = -(myFontSize-pointSize)*(0.5-baselines)/4;
								break;
							}
							underlineOffset += doffset;
						}
						switch (UndrlineType.selectedIndex){
						case 0 : underlineType = "ベタ";
								break ;
						case 1 : underlineType = "二重線";
								break ;
						case 2 : underlineType = "波状";
								break ;
						}
						underlineWeight = eval(UndrlineWeight.editValue);
						underlineColor = mySwatches[ulSwatch.selectedIndex].name;
						underline = true;
					}
				}
				break;
			case 1 :
				with (myStory.characters[StartPtr]){
					if (contents=="（"||contents=="『"){
						leadingAki = 0;
					}
				}
				with (myStory.characters[TerminalPtr]){
					if (contents=="）"||contents=="』"){
						contents=contents + String.fromCharCode("0x2002");
						trailingAki = 0;
					}
				}
				for (var i = StartPtr;i <= TerminalPtr;i ++){
					with (myStory.characters[i]){
						var chroffset = myFontSize * verticalScale / 100 * baselines;
						strikeThroughOffset = - ( - chroffset + eval(UndrlineOffset.editValue)+baselineShift) / 4;//-baselineShift
						if (pointSize != myFontSize){
							var doffset = 0;
							switch (characterAlignment){
							case 1247896436:	//仮想ボディの中央
								doffset = (myFontSize-pointSize)*baselines/4;
								break;
							case 1247900784:	//仮想ボディの上/右
								doffset = (myFontSize-pointSize)*(0.5+baselines)/4;
								break;
							case 1247896173:	//仮想ボディの下/左
								doffset = -(myFontSize-pointSize)*(0.5-baselines)/4;
								break;
							}
							strikeThroughOffset -= doffset;
						}
						switch (UndrlineType.selectedIndex){
						case 0 : strikeThroughType = "ベタ";
								break ;
						case 1 : strikeThroughType = "二重線";
								break ;
						case 2 : strikeThroughType = "波状";
								break ;
						}
						strikeThroughWeight = eval(UndrlineWeight.editValue);
						strikeThroughColor = mySwatches[ulSwatch.selectedIndex].name;
						strikeThru = true;
					}
				}
				break;
			case 2 :
				for (i = StartPtr;i <= TerminalPtr;i ++){
					myStory.characters[i].underline = false;
					myStory.characters[i].strikeThru = false;
				}
				break;
			}
		}
	}
	myDialog.destroy();
	with (myDoc.viewPreferences){ 
		try{ 
			horizontalMeasurementUnits = myOldXUnits; 
			verticalMeasurementUnits = myOldYUnits; 
			typographicMeasurementUnits = myOldTypographUnits;
			textSizeMeasurementUnits = myOldTextUnits;
			lineMeasurementUnits = myOldLineUnits;
		}
		catch(myError){ 
			alert("Could not reset custom measurement units."); 
		}
	}
}

